/**************************************************************************
 * Author: Ayaz ul Hassan Khan
 * Designation: Software Engineer
 * Organization: Wavetech Private Limited
 * Country: Pakistan
 * Date: 11-Nov-2005 17:05:00
 **************************************************************************/
 

#include <stdio.h>
#include <signal.h>

FILE *fptr;
FILE *pptr;
int show_active = 1;
int loading_player = 1;
char params[500];

void signal_handler(int sig)
{
	fclose(fptr);
	exit(0);
}

void user1_handler(int sig)
{
	printf("got user1 signal\n");
	show_active = !show_active;
	if(loading_player == 0){
		printf("pausing playlist_player\n");
		fputs("\npause\n",pptr);
		fflush(pptr);
	} 
	
}

int main(int argc,char *argv[])
{
	char command[256];
	char command1[256+20];
	char data[1000+2];
	char filename[1000];
	char mplayer_exe[500];
	int loop = 0;
	int first_time = 1;
	int param_index=1;
	FILE *pptr1;
	FILE *fifo_ptr;

	strcpy(params,"-loop 1 -slave -vo fbdev -fs -fixed-vo -really-quiet 2> /dev/null > /dev/null");
	strcpy(mplayer_exe,"mplayer");
	
	if(argc < 2){
		printf("Usage: playlist_player [-params \"<mplayer parameters>\"] [-player <mplayer-exe-path>] <playlist_path> [loop]\n");
		exit(0);
	}

	if(argc > 2){
		while(param_index < argc){
			printf("argv[%d]: %s\n",param_index,argv[param_index]);
			if(strncmp(argv[param_index],"-params",7) == 0){
				strcpy(params,argv[++param_index]);
			}
			else if(strncmp(argv[param_index],"-player",7) == 0){
				strcpy(mplayer_exe,argv[++param_index]);
			}
			else if(strncmp(argv[param_index],"loop",4) == 0){
				loop = 1;
			}
			else{
				strcpy(filename,"playlist ");
				strcat(filename,argv[param_index]);
			}
			param_index++;
		}
	}
	else{
		strcpy(filename,"playlist ");
		strcat(filename,argv[param_index]);
	}
	
	signal(SIGINT,signal_handler);
	signal(SIGUSR1,user1_handler);
//	signal(SIGTTOU,user1_handler);
	signal(SIGPIPE,SIG_IGN);

next_file:
	sprintf(command,"%s -%s %s",mplayer_exe,filename,params);
	printf("running: %s\n",command);
	exit(0);
	pptr = popen(command,"w");
	if(pptr != NULL){
		loading_player = 0;
		first_time = 0;
	}
	else{
		printf("error: unable to run command %s\n",command);
		exit(0);
	}
	
	sprintf(command1,"ps -aux | grep \"%s\"",filename);
	while((pptr1 = popen(command1,"r")) != NULL){

		fgets(data,1000,pptr1);
		if(strstr(data,command) == NULL){
			pclose(pptr1);
			break;
		}
		
		pclose(pptr1);
		sleep(1); 
	}
	
	loading_player = 1;	
	pclose(pptr);	

	if(loop)
		goto next_file;
	
	return 0;
}
